﻿Imports System
Imports System.IO
Imports System.Net
Imports System.Windows
Imports System.Windows.Controls
Imports System.Windows.Data
Imports System.Windows.Media
Imports System.Windows.Media.Animation
Imports System.Windows.Navigation

Imports System.Data
Imports System.Data.OleDb
Imports System.Windows.Input

Partial Public Class Window1
	Public Sub New()
		MyBase.New()

		Me.InitializeComponent()

		' Insert code required on object creation below this point.
	End Sub

    Private m_daUsers As OleDbDataAdapter
    Private m_dsStudentData As DataSet

    Private Sub Window_Loaded(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)
        ' Connect to the database.
        Dim conn As New OleDbConnection( _
            "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=StudentData.mdb")

        Try
            ' Open the connection.
            conn.Open()

            ' The DataSet to hold all of the data.
            m_dsStudentData = New DataSet()

            ' Load Students table.
            m_daUsers = New OleDbDataAdapter()
            m_daUsers.SelectCommand = _
                New OleDbCommand("SELECT * FROM Students ORDER BY FirstName, LastName", conn)
            m_daUsers.Fill(m_dsStudentData, "Students")

            ' Load TestScores table.
            Dim daTestScores As New OleDbDataAdapter()
            daTestScores.SelectCommand = _
                New OleDbCommand("SELECT * FROM TestScores", conn)
            daTestScores.Fill(m_dsStudentData, "TestScores")

            ' Load States table.
            Dim daStates As New OleDbDataAdapter()
            daStates.SelectCommand = _
                New OleDbCommand("SELECT * FROM States ORDER BY StateName", conn)
            daStates.Fill(m_dsStudentData, "States")

            ' Relation: States.State = Students.State.
            m_dsStudentData.Relations.Add( _
                "relStates_Students", _
                m_dsStudentData.Tables("States").Columns("State"), _
                m_dsStudentData.Tables("Students").Columns("State"))

            ' Relation: Students.StudentId = TestScores.StudentId.
            m_dsStudentData.Relations.Add( _
                "relStudents_TestScores", _
                m_dsStudentData.Tables("Students").Columns("StudentId"), _
                m_dsStudentData.Tables("TestScores").Columns("StudentId"))

            ' Set the Window's DataContext to the DataSet.
            Me.DataContext = m_dsStudentData
        Catch ex As Exception
            MessageBox.Show(ex.Message)
        Finally
            ' Close the connection.
            conn.Close()
        End Try
    End Sub

    ' Save the changes to the Students table.
    Private Sub mnuDataSaveChanges_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)
        ' Pathetic kludge to move focus off of the current control
        ' so any pending changes are written into the DataSet.
        Dim has_focus As IInputElement = FocusManager.GetFocusedElement(Me)
        txtStreet.Focus()
        txtCity.Focus()
        has_focus.Focus()

        ' Make a command builder to generate the UPDATE command.
        Dim cb As New OleDbCommandBuilder(m_daUsers)

        ' Update the table.
        m_daUsers.Update(m_dsStudentData, "Students")

        MessageBox.Show("Changes saved.", "Changes Saved", _
            MessageBoxButton.OK, MessageBoxImage.Information)
    End Sub
End Class
